<html>
<head>
<title>OGRE: Ogre::LiSPSMShadowCameraSetup Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html">LiSPSMShadowCameraSetup</a></div>
<h1>Ogre::LiSPSMShadowCameraSetup Class Reference</h1><!-- doxytag: class="Ogre::LiSPSMShadowCameraSetup" --><!-- doxytag: inherits="Ogre::FocusedShadowCameraSetup" -->Implements the <a class="el" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a> Space Perspective Shadow Mapping Algorithm.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreShadowCameraSetupLiSPSM_8h-source.html">OgreShadowCameraSetupLiSPSM.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Ogre::LiSPSMShadowCameraSetup:</div>
<div class="dynsection">
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="classOgre_1_1LiSPSMShadowCameraSetup-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#9773b96e56d49b46ae8b71ef94e60e73">LiSPSMShadowCameraSetup</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Default constructor.  <a href="#9773b96e56d49b46ae8b71ef94e60e73"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#a619e8c0071d56b9a020413bb15d93a5">~LiSPSMShadowCameraSetup</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Default destructor.  <a href="#a619e8c0071d56b9a020413bb15d93a5"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#d8969d629ddf8c9e01f22c5342888b99">getShadowCamera</a> (const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *sm, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> *cam, const <a class="el" href="classOgre_1_1Viewport.html">Viewport</a> *vp, const <a class="el" href="classOgre_1_1Light.html">Light</a> *light, <a class="el" href="classOgre_1_1Camera.html">Camera</a> *texCam) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns a LiSPSM shadow camera.  <a href="#d8969d629ddf8c9e01f22c5342888b99"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#a4f0c58ca0ea89aa7e4b11def4976ea6">setOptimalAdjustFactor</a> (<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> n)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Adjusts the parameter n to produce optimal shadows.  <a href="#a4f0c58ca0ea89aa7e4b11def4976ea6"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#af7b2c705eff6b04d001279e7ad5b846">getOptimalAdjustFactor</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the parameter n used to produce optimal shadows.  <a href="#af7b2c705eff6b04d001279e7ad5b846"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#e09cafbe81832dd23c70f85d9435b213">setUseSimpleOptimalAdjust</a> (bool s)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets whether or not to use a slightly simpler version of the camera near point derivation (default is true).  <a href="#e09cafbe81832dd23c70f85d9435b213"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#8fc373347be0c44cc787ff984e3a861f">getUseSimpleOptimalAdjust</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets whether or not to use a slightly simpler version of the camera near point derivation (default is true).  <a href="#8fc373347be0c44cc787ff984e3a861f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#f57854c45cd48033da1cb28e316901dc">setUseAggressiveFocusRegion</a> (bool aggressive)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets whether or not to use the more agressive approach to deciding on the focus region or not.  <a href="#f57854c45cd48033da1cb28e316901dc"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#89fc1444a88d8c20c35ee50a8c518564">getUseAggressiveFocusRegion</a> () const </td></tr>

<tr><td colspan="2"><br><h2>Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#8adae0ea9d0e7f22d4418063fda70e1b">calculateLiSPSM</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;lightSpace, const PointListBody &amp;bodyB, const PointListBody &amp;bodyLVS, const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;sm, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;cam, const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;light) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Calculates the LiSPSM projection matrix P.  <a href="#8adae0ea9d0e7f22d4418063fda70e1b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#35ad9f04a8f64384b65f581a97238ebd">calculateNOpt</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;lightSpace, const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;bodyBABB_ls, const PointListBody &amp;bodyLVS, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;cam) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Calculates the distance between camera position and near clipping plane.  <a href="#35ad9f04a8f64384b65f581a97238ebd"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#992f857c2e95a944dd1be197137a1a47">calculateNOptSimple</a> (const PointListBody &amp;bodyLVS, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;cam) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Calculates a simpler version than the one above.  <a href="#992f857c2e95a944dd1be197137a1a47"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#771d2cfad9388f156de63faacbe4b4fe">calculateZ0_ls</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;lightSpace, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;e, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> bodyB_zMax_ls, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;cam) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Calculates the visible point on the near plane for the n_opt calculation.  <a href="#771d2cfad9388f156de63faacbe4b4fe"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#3926ba17e4a63758954fd2dfd49f5a5e">buildFrustumProjection</a> (<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> left, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> right, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> bottom, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> top, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> near, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> far) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Builds a frustum matrix.  <a href="#3926ba17e4a63758954fd2dfd49f5a5e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#7236f92a6006f84b7441adce882713df">calculateShadowMappingMatrix</a> (const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;sm, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;cam, const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;light, <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *out_view, <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *out_proj, <a class="el" href="classOgre_1_1Camera.html">Camera</a> *out_cam) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Calculates the standard shadow mapping matrix.  <a href="#7236f92a6006f84b7441adce882713df"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#561c5825cdc94896a738e4eb3a0b8852">calculateB</a> (const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;sm, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;cam, const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;light, const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;sceneBB, PointListBody *out_bodyB) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Calculates the intersection bodyB.  <a href="#561c5825cdc94896a738e4eb3a0b8852"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#0706a0e7b7ec6aecf9639dbe5b9cc7a2">calculateLVS</a> (const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;sm, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;cam, const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;light, const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;sceneBB, PointListBody *out_LVS) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Calculates the bodyLVS.  <a href="#0706a0e7b7ec6aecf9639dbe5b9cc7a2"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#5a463b751319df295758fa832e9f8e2d">getLSProjViewDir</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;lightSpace, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;cam, const PointListBody &amp;bodyLVS) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the projection view direction.  <a href="#5a463b751319df295758fa832e9f8e2d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#023ab991324e937410c0b8bc654085e5">getNearCameraPoint_ws</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;viewMatrix, const PointListBody &amp;bodyLVS) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns a valid near-point seen by the camera.  <a href="#023ab991324e937410c0b8bc654085e5"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#1438dc104a74c79bbe98df922e31651b">transformToUnitCube</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;m, const PointListBody &amp;body) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Transforms a given body to the unit cube (-1,-1,-1) / (+1,+1,+1) with a specific shadow matrix enabled.  <a href="#1438dc104a74c79bbe98df922e31651b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#2717983dfbfaff59191bb51fae350ece">buildViewMatrix</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;pos, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;dir, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;up) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Builds a view matrix.  <a href="#2717983dfbfaff59191bb51fae350ece"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#ae134702a175b3f5048364a6e44a0a12">mOptAdjustFactor</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Warp factor adjustment.  <a href="#ae134702a175b3f5048364a6e44a0a12"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#10db7404fd7ff4b65920f35a1e7412d9">mUseSimpleNOpt</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Use simple nopt derivation?  <a href="#10db7404fd7ff4b65920f35a1e7412d9"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Frustum.html">Frustum</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#0ebae20e4252d229af9524a8690ecc11">mTempFrustum</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Temporary preallocated frustum to set up a projection matrix in calculateShadowMappingMatrix().  <a href="#0ebae20e4252d229af9524a8690ecc11"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Camera.html">Camera</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#1cdb9e5c72f7bbb936b2ba84cf605787">mLightFrustumCamera</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Temporary preallocated camera to set up a light frustum for clipping in calculateB.  <a href="#1cdb9e5c72f7bbb936b2ba84cf605787"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#113a55085b7c23a1004a4be9f3155c1c">mLightFrustumCameraCalculated</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#c22ea363ab7fc61d60f0c1518015cb6b">mUseAggressiveRegion</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Use tighter focus region?  <a href="#c22ea363ab7fc61d60f0c1518015cb6b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1ConvexBody.html">ConvexBody</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#e784e0376eb99fa60f2c4a995ccd162e">mBodyB</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">PointListBody&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#84c5bc98d3d36f4e3f858d726d1cb19e">mPointListBodyB</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">PointListBody&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#69328121d415c6e9033ff0e3d7d21cd2">mPointListBodyLVS</a></td></tr>

<tr><td colspan="2"><br><h2>Static Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#2022a48e9e37aa409682d320233cfa09">msNormalToLightSpace</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Transform to or from light space as defined by Wimmer et al.  <a href="#2022a48e9e37aa409682d320233cfa09"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#3c6218ad4ccccd28374444f1ecd2b3d5">msLightSpaceToNormal</a></td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Implements the <a class="el" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a> Space Perspective Shadow Mapping Algorithm. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Implements the LiSPSM algorithm for an advanced shadow map generation. LiSPSM was developed by Michael Wimmer, Daniel Scherzer and Werner Purgathofer of the TU Wien. The algorithm was presented on the Eurographics Symposium on Rendering 2004. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Shadow mapping was introduced by Williams in 1978. First a depth image is rendered from the light's view and compared in a second pass with depth values of the normal camera view. In case the depth camera's depth value is greater than the depth seen by the light the fragment lies in the shadow. The concept has a major draw back named perspective aliasing. The shadow map distri- butes the samples uniformly meaning the position of the viewer is ignored. For the viewer however the perspective projection affects near objects to be displayed bigger than further away objects. The same thing happens with the shadow map texels: Near shadows appear very coarse and far away shadows are perfectly sampled. In 2002 Stamminger et al. presented an algorithm called Perspective Shadow Maps (PSM). PSM battles the perspective aliasing by distributing 50% of the shadow map texels for objects in the range of &lt;near clipping="" plane&gt;=""&gt; to &lt;near clipping plane * 2&gt; which inverts the problem: The shadows near the viewer are perfectly sampled, however far away shadow may contain aliasing artefacts. A near clipping plane may be a problem. But this is not the only one. In the post-perspective space the light sources are non-intuitively mapped: Directional lights may become point light and point lights may become directional lights. Also light sinks (opposite of a light source) may appear. Another problem are shadow casters located behind the viewer. In post-projective space objects behind the viewer are mapped in front of him with a flipped up-vector. LiSPSM battles the light source problem of the post-projective space by rearranging the light space before transformation in such a way that no special cases appear. This is done by converting point/spot lights into directional lights. The light space is arranged in such a way that the light direction equals the inverse UNIT_Y. In this combination the directional light will neither change its type nor its direction. Furthermore all visible objects and shadow casters affecting the user's visible area lie in front of the shadow camera: After building the intersection body that contains all these objects (body intersection building was introduced with PSM; have a look at the description for the method "calculateB" for further info) a frustum around the body's light space bounding box is created. A parameter (called 'n') automatically adjusts the shadow map sample distribution by specifying the frustum's view point - near plane which affects the perspective warp. In case the distance is small the perspecive warp will be strong. As a consequence near objects will gain quality. However there are still problems. PSM as well as LiSPSM only devote to minimize perspective aliasing. Projection aliasing is still a problem, also 'swimming artefacts' still occur. The LiSPSM quality distribution is very good but not the best available: Some sources say logarithmic shadow mapping is the non plus ultra, however others reject this thought. There is a research project on logarithmic shadow maps. The web page url is <a href="http://gamma.cs.unc.edu/logsm/.">http://gamma.cs.unc.edu/logsm/.</a> However there is no techical report available yet (Oct 23rd, 2006). <p>
More information can be found on the webpage of the TU Wien: <a href="http://www.cg.tuwien.ac.at/research/vr/lispsm/">http://www.cg.tuwien.ac.at/research/vr/lispsm/</a> <p>
Original implementation by Matthias Fink &lt;<a href="mailto:matthias.fink@web.de">matthias.fink@web.de</a>&gt;, 2006. </dd></dl>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupLiSPSM_8h-source.html#l00093">93</a> of file <a class="el" href="OgreShadowCameraSetupLiSPSM_8h-source.html">OgreShadowCameraSetupLiSPSM.h</a>.</p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="9773b96e56d49b46ae8b71ef94e60e73"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::LiSPSMShadowCameraSetup" ref="9773b96e56d49b46ae8b71ef94e60e73" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::LiSPSMShadowCameraSetup::LiSPSMShadowCameraSetup           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Default constructor. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Nothing done here. </dd></dl>

</div>
</div><p>
<a class="anchor" name="a619e8c0071d56b9a020413bb15d93a5"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::~LiSPSMShadowCameraSetup" ref="a619e8c0071d56b9a020413bb15d93a5" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Ogre::LiSPSMShadowCameraSetup::~LiSPSMShadowCameraSetup           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Default destructor. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Nothing done here. </dd></dl>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="8adae0ea9d0e7f22d4418063fda70e1b"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::calculateLiSPSM" ref="8adae0ea9d0e7f22d4418063fda70e1b" args="(const Matrix4 &amp;lightSpace, const PointListBody &amp;bodyB, const PointListBody &amp;bodyLVS, const SceneManager &amp;sm, const Camera &amp;cam, const Light &amp;light) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::LiSPSMShadowCameraSetup::calculateLiSPSM           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>lightSpace</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const PointListBody &amp;&nbsp;</td>
          <td class="paramname"> <em>bodyB</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const PointListBody &amp;&nbsp;</td>
          <td class="paramname"> <em>bodyLVS</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>sm</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>cam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>light</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Calculates the LiSPSM projection matrix P. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The LiSPSM projection matrix will be built around the axis aligned bounding box of the intersection body B in light space. The distance between the near plane and the projection center is chosen in such a way (distance is set by the para- meter n) that the perspective error is the same on the near and far plane. In case P equals the identity matrix the algorithm falls back to a uniform shadow mapping matrix. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>lightSpace,:</em>&nbsp;</td><td>matrix of the light space transformation </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>bodyB,:</em>&nbsp;</td><td>intersection body B </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>bodyLVS,:</em>&nbsp;</td><td>intersection body LVS (relevant space in front of the camera) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>sm,:</em>&nbsp;</td><td>scene manager </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>cam,:</em>&nbsp;</td><td>currently active camera </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>light,:</em>&nbsp;</td><td>currently active light </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="35ad9f04a8f64384b65f581a97238ebd"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::calculateNOpt" ref="35ad9f04a8f64384b65f581a97238ebd" args="(const Matrix4 &amp;lightSpace, const AxisAlignedBox &amp;bodyBABB_ls, const PointListBody &amp;bodyLVS, const Camera &amp;cam) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> Ogre::LiSPSMShadowCameraSetup::calculateNOpt           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>lightSpace</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>bodyBABB_ls</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const PointListBody &amp;&nbsp;</td>
          <td class="paramname"> <em>bodyLVS</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>cam</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Calculates the distance between camera position and near clipping plane. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>n_opt determines the distance between light space origin (shadow camera position) and the near clipping plane to achieve an optimal perspective forshortening effect. In this way the texel distibution over the shadow map is controlled.</dd></dl>
Formula: d n_opt = --------------- sqrt(z1/z0) - 1<p>
Parameters: d: distance between the near and the far clipping plane z0: located on the near clipping plane of the intersection body b z1: located on the far clipping plane with the same x/y values as z0 <dl class="note" compact><dt><b>Note:</b></dt><dd>A positive value is applied as the distance between viewer and near clipping plane. In case null is returned uniform shadow mapping will be applied. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>lightSpace,:</em>&nbsp;</td><td>matrix of the light space transformation </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>bodyBABB_ls,:</em>&nbsp;</td><td>bounding box of the tranformed (light space) bodyB </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>bodyLVS,:</em>&nbsp;</td><td>point list of the bodyLVS which describes the scene space which is in front of the light and the camera </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>cam,:</em>&nbsp;</td><td>currently active camera </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="992f857c2e95a944dd1be197137a1a47"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::calculateNOptSimple" ref="992f857c2e95a944dd1be197137a1a47" args="(const PointListBody &amp;bodyLVS, const Camera &amp;cam) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> Ogre::LiSPSMShadowCameraSetup::calculateNOptSimple           </td>
          <td>(</td>
          <td class="paramtype">const PointListBody &amp;&nbsp;</td>
          <td class="paramname"> <em>bodyLVS</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>cam</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Calculates a simpler version than the one above. 
<p>

</div>
</div><p>
<a class="anchor" name="771d2cfad9388f156de63faacbe4b4fe"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::calculateZ0_ls" ref="771d2cfad9388f156de63faacbe4b4fe" args="(const Matrix4 &amp;lightSpace, const Vector3 &amp;e, Real bodyB_zMax_ls, const Camera &amp;cam) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> Ogre::LiSPSMShadowCameraSetup::calculateZ0_ls           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>lightSpace</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>e</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>bodyB_zMax_ls</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>cam</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Calculates the visible point on the near plane for the n_opt calculation. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>z0 lies on the parallel plane to the near plane through e and on the near plane of the frustum C (plane z = bodyB_zMax_ls) and on the line x = e.x. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>lightSpace,:</em>&nbsp;</td><td>matrix of the light space transformation </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>e,:</em>&nbsp;</td><td>the LiSPSM parameter e is located near or on the near clipping plane of the LiSPSM frustum C </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>bodyB_zMax_ls,:</em>&nbsp;</td><td>maximum z-value of the light space bodyB bounding box </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>cam,:</em>&nbsp;</td><td>currently active camera </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="3926ba17e4a63758954fd2dfd49f5a5e"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::buildFrustumProjection" ref="3926ba17e4a63758954fd2dfd49f5a5e" args="(Real left, Real right, Real bottom, Real top, Real near, Real far) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::LiSPSMShadowCameraSetup::buildFrustumProjection           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>left</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>right</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>bottom</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>top</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>near</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>far</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Builds a frustum matrix. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Builds a standard frustum matrix out of the distance infos of the six frustum clipping planes. </dd></dl>

</div>
</div><p>
<a class="anchor" name="d8969d629ddf8c9e01f22c5342888b99"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::getShadowCamera" ref="d8969d629ddf8c9e01f22c5342888b99" args="(const SceneManager *sm, const Camera *cam, const Viewport *vp, const Light *light, Camera *texCam) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::LiSPSMShadowCameraSetup::getShadowCamera           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *&nbsp;</td>
          <td class="paramname"> <em>sm</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> *&nbsp;</td>
          <td class="paramname"> <em>cam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Viewport.html">Viewport</a> *&nbsp;</td>
          <td class="paramname"> <em>vp</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> *&nbsp;</td>
          <td class="paramname"> <em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Camera.html">Camera</a> *&nbsp;</td>
          <td class="paramname"> <em>texCam</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns a LiSPSM shadow camera. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Builds and returns a LiSPSM shadow camera. More information can be found on the webpage of the TU Wien: <a href="http://www.cg.tuwien.ac.at/research/vr/lispsm/">http://www.cg.tuwien.ac.at/research/vr/lispsm/</a> </dd></dl>

<p>Reimplemented from <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#4859f949e592b63e5f211f85f510cb37">Ogre::FocusedShadowCameraSetup</a>.</p>

</div>
</div><p>
<a class="anchor" name="a4f0c58ca0ea89aa7e4b11def4976ea6"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::setOptimalAdjustFactor" ref="a4f0c58ca0ea89aa7e4b11def4976ea6" args="(Real n)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::LiSPSMShadowCameraSetup::setOptimalAdjustFactor           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>n</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Adjusts the parameter n to produce optimal shadows. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The smaller the parameter n, the stronger the perspective warping effect. The consequence of a stronger warping is that the near shadows will gain quality while the far ones will lose it. Depending on your scene and light types you may want to tweak this value - for example directional lights tend to benefit from higher values of n than other types of light, especially if you expect to see more distant shadows (say if the viewpoint is higher above the ground plane). Remember that you can supply separate <a class="el" href="classOgre_1_1ShadowCameraSetup.html" title="This class allows you to plug in new ways to define the camera setup when rendering...">ShadowCameraSetup</a> instances configured differently per light if you wish. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>n</em>&nbsp;</td><td>The adjustment factor - default is 0.1f. </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupLiSPSM_8h-source.html#l00207">207</a> of file <a class="el" href="OgreShadowCameraSetupLiSPSM_8h-source.html">OgreShadowCameraSetupLiSPSM.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="af7b2c705eff6b04d001279e7ad5b846"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::getOptimalAdjustFactor" ref="af7b2c705eff6b04d001279e7ad5b846" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> Ogre::LiSPSMShadowCameraSetup::getOptimalAdjustFactor           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get the parameter n used to produce optimal shadows. 
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#a4f0c58ca0ea89aa7e4b11def4976ea6" title="Adjusts the parameter n to produce optimal shadows.">setOptimalAdjustFactor</a> </dd></dl>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupLiSPSM_8h-source.html#l00211">211</a> of file <a class="el" href="OgreShadowCameraSetupLiSPSM_8h-source.html">OgreShadowCameraSetupLiSPSM.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="e09cafbe81832dd23c70f85d9435b213"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::setUseSimpleOptimalAdjust" ref="e09cafbe81832dd23c70f85d9435b213" args="(bool s)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::LiSPSMShadowCameraSetup::setUseSimpleOptimalAdjust           </td>
          <td>(</td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>s</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sets whether or not to use a slightly simpler version of the camera near point derivation (default is true). 
<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupLiSPSM_8h-source.html#l00215">215</a> of file <a class="el" href="OgreShadowCameraSetupLiSPSM_8h-source.html">OgreShadowCameraSetupLiSPSM.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="8fc373347be0c44cc787ff984e3a861f"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::getUseSimpleOptimalAdjust" ref="8fc373347be0c44cc787ff984e3a861f" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Ogre::LiSPSMShadowCameraSetup::getUseSimpleOptimalAdjust           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets whether or not to use a slightly simpler version of the camera near point derivation (default is true). 
<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupLiSPSM_8h-source.html#l00219">219</a> of file <a class="el" href="OgreShadowCameraSetupLiSPSM_8h-source.html">OgreShadowCameraSetupLiSPSM.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="7236f92a6006f84b7441adce882713df"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::calculateShadowMappingMatrix" ref="7236f92a6006f84b7441adce882713df" args="(const SceneManager &amp;sm, const Camera &amp;cam, const Light &amp;light, Matrix4 *out_view, Matrix4 *out_proj, Camera *out_cam) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::FocusedShadowCameraSetup::calculateShadowMappingMatrix           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>sm</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>cam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *&nbsp;</td>
          <td class="paramname"> <em>out_view</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *&nbsp;</td>
          <td class="paramname"> <em>out_proj</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Camera.html">Camera</a> *&nbsp;</td>
          <td class="paramname"> <em>out_cam</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Calculates the standard shadow mapping matrix. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Provides the view and projection matrix for standard shadow mapping. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>You can choose which things you want to have: view matrix and/or projection matrix and/or shadow camera. Passing a NULL value as parameter ignores the generation of this specific value. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>sm,:</em>&nbsp;</td><td>scene manager </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>cam,:</em>&nbsp;</td><td>currently active camera </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>light,:</em>&nbsp;</td><td>currently active light </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>out_view,:</em>&nbsp;</td><td>calculated uniform view shadow mapping matrix (may be NULL) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>out_proj,:</em>&nbsp;</td><td>calculated uniform projection shadow mapping matrix (may be NULL) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>out_cam,:</em>&nbsp;</td><td>calculated uniform shadow camera (may be NULL) </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="561c5825cdc94896a738e4eb3a0b8852"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::calculateB" ref="561c5825cdc94896a738e4eb3a0b8852" args="(const SceneManager &amp;sm, const Camera &amp;cam, const Light &amp;light, const AxisAlignedBox &amp;sceneBB, PointListBody *out_bodyB) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::FocusedShadowCameraSetup::calculateB           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>sm</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>cam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>sceneBB</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> *&nbsp;</td>
          <td class="paramname"> <em>out_bodyB</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Calculates the intersection bodyB. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The intersection bodyB consists of the concatenation the cam frustum clipped by the scene bounding box followed by a convex hullification with the light's position and the clipping with the scene bounding box and the light frustum: ((V  S) + l)  S  L (: convex intersection, +: convex hull operation). For directional lights the bodyB is assembled out of the camera frustum clipped by the scene bounding box followed by the extrusion of all available bodyB points towards the negative light direction. The rays are intersected by a maximum bounding box and added to the bodyB points to form the final intersection bodyB point list. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>sm,:</em>&nbsp;</td><td>scene manager </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>cam,:</em>&nbsp;</td><td>currently active camera </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>light,:</em>&nbsp;</td><td>currently active light </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>sceneBB,:</em>&nbsp;</td><td>scene bounding box for clipping operations </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>out_bodyB,:</em>&nbsp;</td><td>final intersection bodyB point list </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="0706a0e7b7ec6aecf9639dbe5b9cc7a2"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::calculateLVS" ref="0706a0e7b7ec6aecf9639dbe5b9cc7a2" args="(const SceneManager &amp;sm, const Camera &amp;cam, const Light &amp;light, const AxisAlignedBox &amp;sceneBB, PointListBody *out_LVS) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::FocusedShadowCameraSetup::calculateLVS           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>sm</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>cam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>sceneBB</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> *&nbsp;</td>
          <td class="paramname"> <em>out_LVS</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Calculates the bodyLVS. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Calculates the bodyLVS which consists of the convex intersection operation affecting the light frustum, the view frustum, and the current scene bounding box is used to find suitable positions in the viewer's frustum to build the rotation matrix L_r. This matrix is applied after the projection matrix L_p to avoid an accidental flip of the frustum orientation for views tilted with respect to the shadow map. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>scene,:</em>&nbsp;</td><td>holds all potential occluders / receivers as one single bounding box of the currently active scene node </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>cam,:</em>&nbsp;</td><td>current viewer camera </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>light,:</em>&nbsp;</td><td>current light </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>out_LVS,:</em>&nbsp;</td><td>intersection body LVS (world coordinates) </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="5a463b751319df295758fa832e9f8e2d"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::getLSProjViewDir" ref="5a463b751319df295758fa832e9f8e2d" args="(const Matrix4 &amp;lightSpace, const Camera &amp;cam, const PointListBody &amp;bodyLVS) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> Ogre::FocusedShadowCameraSetup::getLSProjViewDir           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>lightSpace</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>cam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>bodyLVS</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the projection view direction. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>After the matrix L_p is applied the orientation of the light space may tilt for non-identity projections. To prevent a false shadow cast the real view direction is evaluated and applied to the light matrix L. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>lightSpace,:</em>&nbsp;</td><td>matrix of the light space transformation </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>cam,:</em>&nbsp;</td><td>current viewer camera </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>bodyLVS,:</em>&nbsp;</td><td>intersection body LVS (relevant space in front of the camera) </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="023ab991324e937410c0b8bc654085e5"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::getNearCameraPoint_ws" ref="023ab991324e937410c0b8bc654085e5" args="(const Matrix4 &amp;viewMatrix, const PointListBody &amp;bodyLVS) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> Ogre::FocusedShadowCameraSetup::getNearCameraPoint_ws           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>viewMatrix</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>bodyLVS</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns a valid near-point seen by the camera. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Returns a point that is situated near the camera by analyzing the bodyLVS that contains all the relevant scene space in front of the light and the camera in a point list array. The view matrix is relevant because the nearest point in front of the camera should be determined. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>viewMatrix,:</em>&nbsp;</td><td>view matrix of the current camera </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>bodyLVS,:</em>&nbsp;</td><td>intersection body LVS (relevant space in front of the camera) </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="1438dc104a74c79bbe98df922e31651b"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::transformToUnitCube" ref="1438dc104a74c79bbe98df922e31651b" args="(const Matrix4 &amp;m, const PointListBody &amp;body) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::FocusedShadowCameraSetup::transformToUnitCube           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>m</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>body</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Transforms a given body to the unit cube (-1,-1,-1) / (+1,+1,+1) with a specific shadow matrix enabled. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Transforms a given point list body object with the matrix m and then maps its extends to a (-1,-1,-1) / (+1,+1,+1) unit cube </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>m,:</em>&nbsp;</td><td>transformation matrix applied on the point list body </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>body,:</em>&nbsp;</td><td>contains the points of the extends of all valid scene elements which are mapped to the unit cube </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="2717983dfbfaff59191bb51fae350ece"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::buildViewMatrix" ref="2717983dfbfaff59191bb51fae350ece" args="(const Vector3 &amp;pos, const Vector3 &amp;dir, const Vector3 &amp;up) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::FocusedShadowCameraSetup::buildViewMatrix           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>pos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>dir</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>up</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Builds a view matrix. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Builds a standard view matrix out of a given position, direction and up vector. </dd></dl>

</div>
</div><p>
<a class="anchor" name="f57854c45cd48033da1cb28e316901dc"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::setUseAggressiveFocusRegion" ref="f57854c45cd48033da1cb28e316901dc" args="(bool aggressive)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::FocusedShadowCameraSetup::setUseAggressiveFocusRegion           </td>
          <td>(</td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>aggressive</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sets whether or not to use the more agressive approach to deciding on the focus region or not. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>There are 2 approaches that can be used to define the focus region, the more aggressive way introduced by Wimmer et al, or the original way as described in Stamminger et al. Wimmer et al's way tends to come up with a tighter focus region but in rare cases (mostly highly glancing angles) can cause some shadow casters to be clipped incorrectly. By default the more aggressive approach is used since it leads to significantly better results in most cases, but if you experience clipping issues, you can use the less agressive version. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>aggressive</em>&nbsp;</td><td>True to use the more agressive approach, false otherwise. </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00272">272</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="89fc1444a88d8c20c35ee50a8c518564"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::getUseAggressiveFocusRegion" ref="89fc1444a88d8c20c35ee50a8c518564" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::FocusedShadowCameraSetup::getUseAggressiveFocusRegion           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00274">274</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="ae134702a175b3f5048364a6e44a0a12"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::mOptAdjustFactor" ref="ae134702a175b3f5048364a6e44a0a12" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#ae134702a175b3f5048364a6e44a0a12">Ogre::LiSPSMShadowCameraSetup::mOptAdjustFactor</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Warp factor adjustment. 
<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupLiSPSM_8h-source.html#l00097">97</a> of file <a class="el" href="OgreShadowCameraSetupLiSPSM_8h-source.html">OgreShadowCameraSetupLiSPSM.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="10db7404fd7ff4b65920f35a1e7412d9"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::mUseSimpleNOpt" ref="10db7404fd7ff4b65920f35a1e7412d9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#10db7404fd7ff4b65920f35a1e7412d9">Ogre::LiSPSMShadowCameraSetup::mUseSimpleNOpt</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Use simple nopt derivation? 
<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupLiSPSM_8h-source.html#l00099">99</a> of file <a class="el" href="OgreShadowCameraSetupLiSPSM_8h-source.html">OgreShadowCameraSetupLiSPSM.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="2022a48e9e37aa409682d320233cfa09"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::msNormalToLightSpace" ref="2022a48e9e37aa409682d320233cfa09" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#2022a48e9e37aa409682d320233cfa09">Ogre::FocusedShadowCameraSetup::msNormalToLightSpace</a><code> [static, protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Transform to or from light space as defined by Wimmer et al. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Point and spot lights need to be converted to directional lights to enable a 1:1 light mapping. Otherwise a directional light may become a point light or a point sink (opposite of a light source) or point/spot lights may become directional lights or light sinks. The light direction is always -y. </dd></dl>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00062">62</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="3c6218ad4ccccd28374444f1ecd2b3d5"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::msLightSpaceToNormal" ref="3c6218ad4ccccd28374444f1ecd2b3d5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#3c6218ad4ccccd28374444f1ecd2b3d5">Ogre::FocusedShadowCameraSetup::msLightSpaceToNormal</a><code> [static, protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00063">63</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="0ebae20e4252d229af9524a8690ecc11"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::mTempFrustum" ref="0ebae20e4252d229af9524a8690ecc11" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Frustum.html">Frustum</a>* <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#0ebae20e4252d229af9524a8690ecc11">Ogre::FocusedShadowCameraSetup::mTempFrustum</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Temporary preallocated frustum to set up a projection matrix in calculateShadowMappingMatrix(). 
<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00068">68</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="1cdb9e5c72f7bbb936b2ba84cf605787"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::mLightFrustumCamera" ref="1cdb9e5c72f7bbb936b2ba84cf605787" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Camera.html">Camera</a>* <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#1cdb9e5c72f7bbb936b2ba84cf605787">Ogre::FocusedShadowCameraSetup::mLightFrustumCamera</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Temporary preallocated camera to set up a light frustum for clipping in calculateB. 
<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00072">72</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="113a55085b7c23a1004a4be9f3155c1c"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::mLightFrustumCameraCalculated" ref="113a55085b7c23a1004a4be9f3155c1c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#113a55085b7c23a1004a4be9f3155c1c">Ogre::FocusedShadowCameraSetup::mLightFrustumCameraCalculated</a><code> [mutable, protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00073">73</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="c22ea363ab7fc61d60f0c1518015cb6b"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::mUseAggressiveRegion" ref="c22ea363ab7fc61d60f0c1518015cb6b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#c22ea363ab7fc61d60f0c1518015cb6b">Ogre::FocusedShadowCameraSetup::mUseAggressiveRegion</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Use tighter focus region? 
<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00076">76</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="e784e0376eb99fa60f2c4a995ccd162e"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::mBodyB" ref="e784e0376eb99fa60f2c4a995ccd162e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ConvexBody.html">ConvexBody</a> <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#e784e0376eb99fa60f2c4a995ccd162e">Ogre::FocusedShadowCameraSetup::mBodyB</a><code> [mutable, protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00139">139</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="84c5bc98d3d36f4e3f858d726d1cb19e"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::mPointListBodyB" ref="84c5bc98d3d36f4e3f858d726d1cb19e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PointListBody <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#84c5bc98d3d36f4e3f858d726d1cb19e">Ogre::FocusedShadowCameraSetup::mPointListBodyB</a><code> [mutable, protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00140">140</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="69328121d415c6e9033ff0e3d7d21cd2"></a><!-- doxytag: member="Ogre::LiSPSMShadowCameraSetup::mPointListBodyLVS" ref="69328121d415c6e9033ff0e3d7d21cd2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PointListBody <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#69328121d415c6e9033ff0e3d7d21cd2">Ogre::FocusedShadowCameraSetup::mPointListBodyLVS</a><code> [mutable, protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00141">141</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShadowCameraSetupLiSPSM_8h-source.html">OgreShadowCameraSetupLiSPSM.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:53:36 2008
</p>
</body>
</html>
